# Makefile business common to directories: Basically
# just redirect make targets on to the $(SUBDIRS).  Only
# subtlety is that some shells heave on empty for lists like
# 'for i in ; do', so 'for i in $(SUBDIRS)' could die if
# $(SUBDIRS) was empty.  So we crock around that.

all clean realclean depend install:
	@export list="$(SUBDIRS)" ; for i in $$list ; do \
	     (cd $$i && ( $(MAKE) $(MFLAGS) $@ || exit $? ) ); \
	 done

clean realclean: dirclean

dirclean:
	@rm -f *~ core
